/***********************************************************************************************************************
 *
 * blueMarine Metadata - open source media workflow
 * Copyright (C) 2007-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluemarine.tidalwave.it
 * SCM: https://kenai.com/hg/bluemarine~metadata-src
 *
 **********************************************************************************************************************/
package it.tidalwave.metadata.persistence;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;

class ItemClass
  {    
  }

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 ******************************************************************************/
public class MetadataPropertyTest 
  {
    private MetadataPropertySet propertySet;
    private MetadataProperty<?> property1;
    private MetadataProperty<?> property2;
    
    @Before
    public void setupFixtures()
      {
        propertySet = new MetadataPropertySet(ItemClass.class);
        property1 = new MetadataProperty<Object>(propertySet, "ITEM1");
        property2 = new MetadataProperty<Object>(property1, "ITEM2");
      }
    
    @After
    public void tearDownFixtures()
      {
        propertySet = null;
        property1 = null;
        property2 = null;
      }
    
    @Test
    public void testGetItem() 
      {
        assertEquals(ItemClass.class, propertySet.getItemClass());
        assertEquals(ItemClass.class, property1.getItemClass());
        assertEquals(ItemClass.class, property2.getItemClass());
      }

    @Test
    public void testGetPropertyName() 
      {
        assertEquals("ITEM1", property1.getPropertyName());
        assertEquals("ITEM2", property2.getPropertyName());
      }

    @Test
    public void testGetParent() 
      {
        assertNull(propertySet.getParent());
        assertTrue(propertySet == property1.getParent());
        assertTrue(property1 == property2.getParent());
      }

//    @Test
//    public void testGetValues() 
//      {
//      }

//    @Test
//    public void testGetBindCount() 
//      {
//        assertEquals(0, property1.getBindCount());
//        assertEquals(0, property2.getBindCount());
//      }
//
    @Test
    public void testToString() 
      {
        assertEquals("MetadataProperty[ITEM1]", property1.toString());
        assertEquals("MetadataProperty[ITEM2]", property2.toString());
      }
  }